Command Line Arguments

Command-Line Arguments and Environment Variables

The following is a list of options available when running ParaView from the command line. When two options are listed, separated by a comma, either of them can be used to achieve the specified result. Unless otherwise specified, all command-line options are used on the client program. Following the list of command-line options is a set of environment variables ParaView recognizes.

General Options

- --data : Load the specified data file into ParaView (--data=data_file).

- --disable-registry, -dr : Launch ParaView in its default state; do not load any preferences saved in ParaView’s registry file.

- --help, /? : Display a list of the command-line arguments and their descriptions.

- --version, -V : Display ParaView’s version number, and then exit.

Client-Server Options

- --server, -s : Tell the client process where to connect to the server. The default is server =localhost. This command-line option is used on the client.

- --client-host, -ch : Tell the server process(es) where to connect to the client. The default is client-host=localhost. This command-line option is used on the server(s).

- --server-port, -sp : Specify the port to use in establishing a connection between the client and the server. The default is --server-port=11111. If used, this argument must be specified on both the client and the server command lines, and the port numbers must match.

- --data-server-port, -dsp : Specify the port to use in establishing a connection between the client and the data server. The default is --data-server-port=11111. If used, this argument must be specified on both the client and the data server command lines, and the port numbers must match.

- --render-server-port, -rsp : Specify the port to use in establishing a connection between the client and the render server. The default is --render-server-port=22221. If used, this argument must be specified on both the client and the render server command lines, and the port numbers must match.

- --reverse-connection, -rc : Cause the data and render servers to connect to the client. When using this option, the client, data server, and render server (if used) must be started with this command-line argument, and you should start the client before starting either server.

- --connect-id : Using a connect ID is a security feature in client-server mode. To use this feature, pass this command-line argument with the same ID number to the client and server(s). If you do not pass the same ID number, the server(s) will be shut down.

- --machines, -m : Use this command-line argument to pass in the network configuration file for the render server. See section Error: Reference source not found for a description of this file.

Rendering Options

- --stereo : Enable stereo rendering in ParaView.

- --stereo-type: Set the stereo rendering type. Options are: Crystal Eyes, Red-Blue, Interlaced ( Default ), Dresden, Anaglyph, Checkerboard

- --tile-dimensions-x, -tdx : Specify the number of tiles in the horizontal direction of the tiled display ( tile dimensions-x=number_of_tiles). This value defaults to 0. To use this option, you must be running in client/server or client/data server/render server mode, and this option must be specified on the client command line. Setting this option to a value greater than 0 will enable the tiled display. If this argument is set to a value greater than 0 and -tdy (see below) is not set, then -tdy will default to 1.

- --tile-dimensions-y, -tdy : Specify the number of tiles in the vertical direction of the tiled display ( tile dimensions-y=number_of_tiles). This value defaults to 0. To use this option, you must be running in client/server or client/data server/render server mode, and this option must be specified on the client command line. Setting this option to a value greater than 0 will enable the tiled display. If this argument is set to a value greater than 0 and -tdx (see above) is not set, then -tdx will default to 1.

- --tile-mullion-x, -tmx : Specify the spacing (in pixels) between columns in tiled display images.

- --tile-mullion-y, -tmy : Specify the spacing (in pixels) between rows in tiled display images.

- --use-offscreen-rendering : Use offscreen rendering on the satellite processes. On unix platforms, software rendering or mangled Mesa must be used with this option.

- --disable-composite, -dc : Use this command-line option if the data server does not have rendering resources and you are not using a render server. All the rendering will then be done on the client.

Executable help

paraview --help

- --connect-id=opt Set the ID of the server and client to make sure they match.
- --cslog=opt ClientServerStream log file.
- --data=opt Load the specified data. To specify file series replace the numeral with a '.' eg. my0.vtk, my1.vtk...myN.vtk becomes my..vtk
- --data-directory=opt Set the data directory where test-case data are.
- --disable-light-kit When present, disables light kit by default. Useful for dashboard tests.
- --disable-registry -dr Do not use registry when running ParaView (for testing).
- --exit Exit application when testing is done. Use for testing.
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --script=opt Set a python script to be evaluated on startup.
- --server=opt -s=opt Set the name of the server resource to connect with when the client starts.
- --state=opt Load the specified statefile (.pvsm).
- --stereo Tell the application to enable stereo rendering (only when running on a single process).
- --stereo-type=opt Specify the stereo type. This valid only when --stereo is specified. Possible values are "Crystal Eyes", "Red-Blue", "Interlaced", "Dresden", "Anaglyph", "Checkerboard"
- --test-baseline=opt Add test baseline. Can be used multiple times to specify multiple baselines for multiple tests, in order.
- --test-directory=opt Set the temporary directory where test-case output will be stored.
- --test-script=opt Add test script. Can be used multiple times to specify multiple tests.
- --test-threshold=opt Add test image threshold. Can be used multiple times to specify multiple image thresholds for multiple tests in order.
- --version -V Give the version number and exit.

pvbatch --help

- --cslog=opt ClientServerStream log file.
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --symmetric -sym When specified, the python script is processed symmetrically on all processes.
- --use-offscreen-rendering Render offscreen on the satellite processes. This option only works with software rendering or mangled mesa on Unix.
- --version -V Give the version number and exit.

pvdataserver --help

- --client-host=opt -ch=opt Tell the data|render server the host name of the client, use with -rc.
- --connect-id=opt Set the ID of the server and client to make sure they match.
- --cslog=opt ClientServerStream log file.
- --data-server-port=opt -dsp=opt What port data server use to connect to the client. (default 11111).
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --reverse-connection -rc Have the server connect to the client.
- --timeout=opt Time (in minutes) since connecting with a client after which the server may timeout. The client typically shows warning messages before the server times out.
- --version -V Give the version number and exit.

pvpython --help

- --connect-id=opt Set the ID of the server and client to make sure they match.
- --cslog=opt ClientServerStream log file.
- --data=opt Load the specified data. To specify file series replace the numeral with a '.' eg. my0.vtk, my1.vtk...myN.vtk becomes my..vtk
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --state=opt Load the specified statefile (.pvsm).
- --stereo Tell the application to enable stereo rendering (only when running on a single process).
- --stereo-type=opt Specify the stereo type. This valid only when --stereo is specified. Possible values are "Crystal Eyes", "Red-Blue", "Interlaced", "Dresden", "Anaglyph", "Checkerboard"
- --version -V Give the version number and exit.

pvrenderserver --help

- --client-host=opt -ch=opt Tell the data|render server the host name of the client, use with -rc.
- --connect-id=opt Set the ID of the server and client to make sure they match.
- --cslog=opt ClientServerStream log file.
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --render-server-port=opt -rsp=opt What port should the render server use to connect to the client. (default 22221).
- --reverse-connection -rc Have the server connect to the client.
- --tile-dimensions-x=opt -tdx=opt Size of tile display in the number of displays in each row of the display.
- --tile-dimensions-y=opt -tdy=opt Size of tile display in the number of displays in each column of the display.
- --tile-mullion-x=opt -tmx=opt Size of the gap between columns in the tile display, in Pixels.
- --tile-mullion-y=opt -tmy=opt Size of the gap between rows in the tile display, in Pixels.
- --use-offscreen-rendering Render offscreen on the satellite processes. This option only works with software rendering or mangled mesa on Unix.
- --version -V Give the version number and exit.

pvserver --help

- --client-host=opt -ch=opt Tell the data|render server the host name of the client, use with -rc.
- --connect-id=opt Set the ID of the server and client to make sure they match.
- --cslog=opt ClientServerStream log file.
- --disable-composite -dc Use this option when rendering resources are not available on the server.
- --help /? Displays available command line arguments.
- --machines=opt -m=opt Specify the network configurations file for the render server.
- --reverse-connection -rc Have the server connect to the client.
- --server-port=opt -sp=opt What port should the combined server use to connect to the client. (default 11111).
- --tile-dimensions-x=opt -tdx=opt Size of tile display in the number of displays in each row of the display.
- --tile-dimensions-y=opt -tdy=opt Size of tile display in the number of displays in each column of the display.
- --tile-mullion-x=opt -tmx=opt Size of the gap between columns in the tile display, in Pixels.
- --tile-mullion-y=opt -tmy=opt Size of the gap between rows in the tile display, in Pixels.
- --timeout=opt Time (in minutes) since connecting with a client after which the server may timeout. The client typically shows warning messages before the server times out.
- --use-offscreen-rendering Render offscreen on the satellite processes. This option only works with software rendering or mangled mesa on Unix.
- --version -V Give the version number and exit.

Environment Variables

In addition to the command-line options previously listed, ParaView also recognizes the following environment variables.

- PV_DISABLE_COMPOSITE_INTERRUPTS If this variable is set to 1, it is not possible to interrupt the compositing of images in parallel rendering. Otherwise it is interruptible through mouse interaction.

- PV_ICET_WINDOW_BORDERS Setting this variable to 1 when running ParaView in tiled display mode using IceT causes the render window for each tile to be the same size as the display area in ParaView’s main application window. (Normally each render window fills the whole screen when tiled display mode is used.) This feature is sometimes useful when debugging ParaView.

- PV_PLUGIN_PATH If you have shared libraries containing plugins you wish to load in ParaView at startup, set this environment variable to the path for these libraries.

- PV_SOFTWARE_RENDERING This environment variable has the same effect as setting both the use software rendering and --use-satellite-software environment variables.

- VTK_CLIENT_SERVER_LOG If set to 1, a log file will be created for the ParaView client, server, and render server. The log files will contain any client-server streams sent to the corresponding client, server, or render server.

Application Settings

Application Settings

Application wide settings are saved in between sessions so that every time you start ParaView on the same machine you get the same behaviors. The settings are stored in an XML file that resides at %APPDATA%\ParaView\ParaViewVERSION.ini on Windows and ~/.config/ParaView/ParaViewVERSION.ini on all other platforms. If you need to restore ParaView's default settings you can either move this file or run with the --disable-registry argument.

These settings are managed via the settings dialog. On Macintosh this is reached from the Preferences entry in the ParaView menu. On Unix, Linux and Windows systems it is reached from the Settings entry on the Edit menu. These settings are program wide and are not to be confused with the View settings found under the Edit menu. Those settings are specific to each View window and are discussed in the Displaying Data chapter.

The following figures show the various pages within the settings dialog. Choose from among them by clicking on the page list toward the left. Click on the arrow to expose the three sub pages in the Render View settings category. Some plugins add their own pages to the dialog but we do not discuss them here and instead refer you to any documentation that comes along with the plugin. Do note though that most settings are documented within the application via tool tips.

General

Figure 17.1. General Preferences

- Default View : Choose the View window type that ParaView initially shows when it starts up and connects to any server.

- On File Open : Control the time step shown by default when ParaView opens a file with multiple time steps.

- Rescale Data Range Mode : Controls how color lookup tables are adjusted when data ranges change

- Heart-Beat Interval : Sets the length of time between keep alive messages that the client sends to the remote server which prevents the TCP connection between the two machines from shutting down.

- Auto Accept : Makes every change take effect immediately rather than requiring you to click the Apply button.

- Auto Convert Properties : Tells ParaView to do some data conversions automatically so that more filters are immediately applicable to the data you have at hand.

- Crash Recovery : Tells ParaView to save a record of each action you take so that you can easily recover your work if ParaView crashes mid-session.

- Use Multi-Core : Tells ParaView to spawn an MPI parallel server on the same machine that is running the GUI so to better take advantage of multi-core machines on processing bound problems.

- Use Strict Load Balancing : Tells ParaView to not use its own extents translators.

- Specular Highlighting with Scalar Coloring : Tells ParaView to enable specular highlighting even when coloring data by scalar values.

- Disable Splash Screen : Tells ParaView to not show its splash screen when starting.

Colors

Figure 17.2. Color Preferences

When setting up visualizations, most datasets in the visualization are typically colored using scalar colors. However, there may be items in the setup that are simply colored using a solid color including text and other annotations. Also by default ParaView uses a grey background, so the default colors chosen for objects tends to be setup so that it looks appropriate on the grey background. However, when saving a screenshot for printing, you may prefer to white background, for example. In that case, it can be tedious to go to every object and change its color to work with the new background color.

To make it easier to change colors on the fly, ParaView defines color categories. Users can choose to assign a color category to any object when specifying a color using the category menu on most color-chooser buttons, as shown below.

Figure 17.3. Color Category on the Display Tab

Following associations are setup by default:

- Foreground color: Outlines and wireframes

- Background color: Background color in render views

- Surface color: Solid color to surfaces

- Text color: Color to 2D text

- Selection color: Color used to show highlighted/selected elements in render view.

- Egde color: Used for edges in Surface With Edges mode.

Animation

Figure 17.4. Animation Preferences

- Cache Geometry : When checked this allows ParaView to save and later reuse rather than regenerate visible geometry during animation playback to speed up replay.

- Cache Limit : This is the maximum size of the animation playback geometry cache (on each node when in parallel).

Charts

Figure 17.5. Chart Preferences

- Hidden Series : Allows you to specify a set of regular expressions that are compared against array names so that various bookkeeping arrays are not drawn in 2D charts and thus distract from the meaningful ones.

Render View General

Figure 17.6. General Render View Preferences

- Use Immediate Mode Rendering : Controls whether OpenGL display lists are used or not. This is generally only faster only when rendering relatively small amounts of geometry.

The LOD Parameters settings control if, when and to what extent ParaView will down sample the data it draws while you move the mouse so to maintain interactivity. The algorithm by which ParaView down samples the data is known as quadric clustering.

- LOD Threshold : Rendered data that is smaller than the specified size is not down sampled.

- LOD Resolution : When data is down sampled, this controls how coarsely.

- Outline threshold : Data that is larger than this threshold is drawn only as a bounding box while you move the camera.

- Lock Interactive Render : Controls how long ParaView waits after you have released the mouse and finished moving the camera before it returns to a full resolution render.

- Allow Rendering Interrupts : makes the drawing process interuptable so that you can move the camera immediately, without having to wait for a potentially slow full resolution render to complete.

The Depth Peeling settings control the algorithm that ParaView uses (given a sufficiently capable GPU) to draw translucent geometry correctly.

- Enable Depth Peeling : Controls whether ParaView will try to use the (potentially slow) depth peeling algorithm at all.

- Number of Peels : Controls the number of passes in the rendering algorithm. A higher number of peels produces quality images but increases rendering time.

The Coincident Topology Resolution settings control the method that ParaView uses to draw co-planar polygons in a non conflicting way (to avoid z-tearing in graphics terminology). Changes to these parameters do not take effect until ParaView is restarted.

The pull down menu allows you to choose between various algorithms that deal with z-tearing.

1. Do Nothing : does not attempt to resolve overlapping geometry

2. Use Z-Buffer Shift : adjusts OpenGL's Z direction scaling to draw one object slightly in front of the other. The Z Shift property controls the amount of offset.

3. Use Polygon Offset : adjusts polygon locations (by calling glPolygonOffset()) for the same purpose. For an explanation of the Factor and Units parameters, see http://www.opengl.org/resources/faq/technical/polygonoffset.htm. The Offset Faces parameters controls whether filled polygons are moved rather than the points and edges.

- Use Offscreen Rendering for Screenshots : This checkbox is enabled only when offscreen rendering is available. It tells ParaView to generate images that are being captured as screenshots in offscreen contexts. On some platforms this is necessary to avoid accidentally capturing overlapping pixels (such as a mouse pointer) from the operating system.

Render View Camera

Figure 17.7. Camera Preferences

These settings allow you to assign particular key/mouse press combinations to various camera moving controls. There are two sets of settings. Control for 3D Movements pertain to the 3D View. Control for 2D Movements pertain to the 2D View.

In the 3D View controls you can assign the following motions to any combination of left, middle or right mouse button press and no, shift or control key press.

- Pan

- Roll

- Rotate

- Multi-Rotate

- Zoom

Rotation is not possible in the 2D View, which lacks a down direction to move about. So in this area you can only choose from Pan and Zoom.

Clicking Reset Defaults restores the button assignments to the factory settings.

Render View Server

Figure 17.8. Server Preferences

These settings control how and where rendering happens when you are connected to a remote server.

The Remote Rendering Parameters are controls that generally affect the break-up of rendering work between the remote server and the local client machine.

- Remote Render Theshold : Geometry that is smaller than the set value will be delivered to the client for local rendering. Data that is larger than the set value will be rendered remotely and pixels will be sent instead.

- Client Outline Threshold : While the camera is being manipulated and the geometry is being rendered locally, or in tiled display mode when it is being rendered both locally and remotely, data that is larger than this threshold will be rendered as a bounding box to maintain interactivity

- Suppress Ordered Compositing : This setting turns of the relatively slow transfer of data that must happen in parallel in order to render translucent geometry (as in volume rendering for instance) correctly.

The Client/Server Parameters section has controls that affect how pixels are transferred between the render server and the client while the data is being rendered remotely and images rather than geometry are being delivered to the client. The Apply presets for ... menu allows you to choose from a set of default settings which are generally well suited to particular network connection bandwidths.

- Interactive Subsample Rate : This setting controls how coarsely the image is down sampled to maintain interactivity while the camera is being manipulated.

- Image Compression : Enables compression of images during interaction. You can choose from either of the two image compression algorithms:

1. Squirt : Chooses IceT's native squirt image compression algorithm. The slider to the right controls the colorspace fidelity of the compression and conversely the interactive responsiveness.

1. Zlib : Chooses the ZLib library's compression algorithm instead. The spin box to the right specifies a compression level (1 through 9). The slider controls the colorspace fidelity. The Strip Alpha checkbox removes the Opacity channel (if any) from the shipped images.

The Tile Display Parameters section contains controls that take effect when doing tiled display wall rendering.

- Still Subsample Rate : This puts a screen space coarseness limit on the normally full resolution rendering that happens once you release the mouse after moving the camera. Image compositing time can prevent interactivity when working with large displays. This limit allows you to preview your results quickly and then choose to render truly full resolution results only once when you are satisfied with the preview.

- Compositing Threshold : This threshold allows you to get faster rendering times in the circumstance that you are visualizing relatively small datasets on large tiled displays. When the geometry size is below the threshold, the geometry is broadcast to all nodes in the render server. After this broadcast the relatively slow tiled image compositing algorithm is entirely omitted.